#!/bin/bash
echo "`date` - Creating .sql file"
SQL_FNAME='build_range_3.sql'
rm -f ${SQL_FNAME}
echo "drop table g30782_broad;" >> ${SQL_FNAME}
echo "CREATE TABLE g30782_broad (" >> ${SQL_FNAME}
echo "  lad     REAL," >> ${SQL_FNAME}
echo "  lad_age_uncertainty     REAL," >> ${SQL_FNAME}
echo "  fad     REAL," >> ${SQL_FNAME}
echo "  fad_age_uncertainty     REAL," >> ${SQL_FNAME}
echo "  genus   TEXT," >> ${SQL_FNAME}
echo "  genus_count     bigint," >> ${SQL_FNAME}
echo "  tax_class       TEXT," >> ${SQL_FNAME}
echo "  tax_class_count bigint," >> ${SQL_FNAME}
echo "  environment     TEXT," >> ${SQL_FNAME}
echo "  environment_count       bigint" >> ${SQL_FNAME}
echo ");" >> ${SQL_FNAME}
#
ALL_GENERA=`psql sed_rock -t --command "select distinct genus from pd where genus is not null and genus<>'-';" | grep -v '\.$'`
#
echo "" >> ${SQL_FNAME}
for genus in ${ALL_GENERA}; do
   echo "select * into foo30782_broad from pd where genus='${genus}';" >> ${SQL_FNAME}
   echo "insert into g30782_broad values ((select min(ma_youngest) from foo30782_broad),(select ma_oldest-ma_youngest from (select min(ma_youngest),ma_youngest,ma_oldest from foo30782_broad group by ma_youngest,ma_oldest order by min limit 1) as foobar),(select max(ma_oldest) from foo30782_broad),(select ma_oldest-ma_youngest from (select max(ma_oldest),ma_oldest,ma_youngest from foo30782_broad group by ma_youngest,ma_oldest order by max desc limit 1) as foobar),'${genus}',(select count(*) from foo30782_broad),(select tax_class from (select tax_class,count(tax_class) from foo30782_broad group by tax_class order by count desc limit 1) as foobar),(select count from (select tax_class,count(tax_class) from foo30782_broad group by tax_class order by count desc limit 1) as foobar),(select environment from (select environment,count(environment) from foo30782_broad group by environment order by count desc limit 1) as foobar),(select count from (select environment,count(environment) from foo30782_broad group by environment order by count desc limit 1) as foobar));" >> ${SQL_FNAME}
      echo "drop table foo30782_broad;"  >> ${SQL_FNAME}
done
echo "`date` - Processing .sql file"
time psql sed_rock < ${SQL_FNAME}
echo "`date` - Done."
